-- Schema: C6Mart
-- Stored Procedure: DM_GestioneEmailNOPRO

-- =============================================
-- Author:		<Valerio,,Name>
-- Create date: <19/14/2011,,> -1 ai -2!
-- Description:	<Popola la tabella email con i clienti con profilo scaduto>
-- =============================================
CREATE procedure [C6Mart].[DM_GestioneEmailNOPRO]
AS
BEGIN

BEGIN TRANSACTION	

DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @MaxInvioSoll SMALLINT
DECLARE @ID_ELAB INT

SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint)
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') AS SMALLINT) --7
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') AS SMALLINT)
SET @ID_ELAB = C6MART.GETIDELAB()

-- Log esecuzione
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'DM_GestioneEmailNOPRO',
	GETDATE(),
	'Elaborazione giornaliera'
)

-- 1. INSERIMENTO MAIL "SOLLECITI"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA ATTIVATO UN PROFILO VALIDO AL CLIENTE
	-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
		
	INSERT INTO C6Mart.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT 
		C6.rete,
		C6.cod_fiscale,
		CASE 
			WHEN ISNULL(numSolleciti,0) = 0 THEN '1_SOLL_NOPRO'
			WHEN numSolleciti = 1 THEN '2_SOLL_NOPRO'
			WHEN numSolleciti = 2 THEN '3_SOLL_NOPRO'
			ELSE 'S_SOLL_NOPRO'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM c6mart.contrattosei C6 
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND C6.RETE = PF.RETE
	WHERE 1 = 1
		AND numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(numSolleciti,0) = 0 AND DATEDIFF(DAY,C6.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(C6.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND c6.clienteMigrato = 'S' 
		AND c6.risorseNA = 'N'
		AND c6.profiloAttivo = 0
		AND C6.Data_FineAvanzato IS NULL
		--AND C6.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'DM_GestioneEmailNOPRO'
		)

	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'DM_GestioneEmailNOPRO',
		GETDATE(),
		'Elaborazione giornaliera'
	)

-- 1.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
	-- AUMENTIAMO IL NUMERO numSolleciti
	-- AGGIORNIAMO LA DATA Data_UltimoSollecito

	UPDATE 
		c6mart.contrattosei
	SET 
		numSolleciti = isnull(numSolleciti,0) + 1,
		Data_UltimoSollecito = getDate()
	FROM c6mart.contrattosei C6 
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND C6.RETE = PF.RETE
	WHERE 1 = 1
		AND numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(numSolleciti,0) = 0 AND DATEDIFF(DAY,C6.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(C6.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)
		AND c6.clienteMigrato = 'S' 
		AND c6.risorseNA = 'N'
		AND c6.profiloAttivo = 0
		AND C6.Data_FineAvanzato IS NULL
		--AND C6.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'UPDATE',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'DM_GestioneEmailNOPRO'
		)

	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'DM_GestioneEmailNOPRO',
		GETDATE(),
		'Elaborazione giornaliera'
	)

-- 2. INSERIMENTO MAIL "REVOCA"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIO
